package recap.oo;

import java.util.ArrayList;
import java.util.List;

public class HarbourOO {

    public static void main(String[] args) {
        new HarbourOO().program();
    }

    private void program() {
    }


    public class Ship {
        String id;
        int length;
        int depth;

        // setter/getter omitted

        public int getLength() {
            return length;
        }

        public int getDepth() {
            return depth;
        }
    }

    class QuayPlace {
        String id;
        private final int length;
        private final int depth;
        private Ship ship;
        private String period;

        public QuayPlace(String id, int length, int depth) {
            this.id = id;
            this.length = length;
            this.depth = depth;
        }

        public void setShip(Ship ship, String period) {
            this.ship = ship;
            this.period = period;
        }

        public boolean isOccupied() {
            return ship != null;
        }

        public int getLength() {
            return length;
        }

        public int getDepth() {
            return depth;
        }
        // setter/getter omitted
    }


    public class Quay {
        List<QuayPlace> places = new ArrayList<>();

        public boolean add(Ship ship, String period) {
            for (QuayPlace p : places) {
                if (!p.isOccupied() && p.getDepth() > ship.getDepth()
                        && p.getLength() > ship.getLength()) {
                    p.setShip(ship, period);
                    return true;
                }
            }
            return false;
        }
    }

    public class Harbour {
        List<Quay> quays = new ArrayList<>();

    }

}
